SystemOrganization addCategory: #'Magma seaside'!

WASystemConfiguration subclass: #WAMagmaConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seaside'!

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'mmb 12/5/2005 09:17'!
ancestors

	^ Array with: (WARenderLoopConfiguration new)! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'brp 11/4/2005 12:17'!
attributes
    "Return the attributes specific to this configuration"

	^ Array with: (WAMagmaLocationAttribute key: #location group: #magma)
! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'brp 11/4/2005 11:44'!
location

	^ MagmaLocalLocation default
! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 11:35'!
repositoryPath

	^ 'store'
! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 11:24'!
sessionClass

	^ WAMagmaSession! !

WASession subclass: #WAMagmaSession
	instanceVariableNames: 'magmaSession'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seaside'!

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 12:53'!
commit: aBlock

	self magmaSession commit: aBlock
! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 12:58'!
expire

	super expire.
	magmaSession ifNotNil: [ magmaSession disconnect. magmaSession := nil ]! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'brp 11/4/2005 12:19'!
magmaSession

	^ magmaSession ifNil: [ 
		magmaSession := (self application preferenceAt: #location) newSession.
		magmaSession connectAs: 'seaside'.
		magmaSession ]! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 12:56'!
repositoryPath
	"This is a convenience method to get the repository directory path from Seaside"

	^ FileDirectory default fullNameFor: (self application preferenceAt: #repositoryPath)! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 12:52'!
root

	^ self magmaSession root
! !

!WAConfigurationEditor methodsFor: '*Magma seaside' stamp: 'brp 7/7/2006 17:43'!
renderMagmaLocationAttribute: anAttribute on: html

	| location |
	location := configuration valueForAttribute: anAttribute.

	html div
		id: 'location';
		with: [
			html table: [
				location isLocal
					ifTrue: [
						html tableRow with: [
							html tableData: [ html label: 'path:' ].
							html tableData: [ html textInput on: #path of: location ] ] ]
					ifFalse: [
						html tableRow with: [
							html tableData: [ html label: 'path:' ].
							html tableData: [ html textInput on: #host of: location ] ].
						html tableRow with: [
							html tableData: [ html label: 'port:' ].
							html tableData: [
								html textInput 
									value: location port;
									callback: [ :v | location port: v asNumber ] ] ] ] ] ]
! !

!WAConfigurationEditor methodsFor: '*Magma seaside' stamp: 'brp 7/10/2006 08:56'!
visitMagmaLocationAttribute: anAttribute with: html

	| location |
	location := configuration valueForAttribute: anAttribute.

	html select
		list: anAttribute options;
		selected: location class;
		labels: [ :ea | ea name ];
		callback: 
			[ :item |
			(configuration valueAt: #location) class = item
				ifFalse: [ configuration takeValue: item default forAttribute: anAttribute ] ];
		beSubmitOnChange.

	self renderMagmaLocationAttribute: anAttribute on: html.! !

WAConfigurationAttribute subclass: #WAMagmaLocationAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seaside'!

!WAMagmaLocationAttribute methodsFor: 'as yet unclassified' stamp: 'brp 11/4/2005 10:00'!
accept: aVisitor with: anObject

	^ aVisitor visitMagmaLocationAttribute: self with: anObject! !

!WAMagmaLocationAttribute methodsFor: 'as yet unclassified' stamp: 'brp 11/4/2005 12:13'!
options

	^ MagmaLocation subclasses! !
